' I write QBASIC 4.5 programs and recently begain (again) using DDOS 5.0
' as an easy way to share resources with my RBBS and my developing
' QBASIC code.
'
' Unfortunately, I found no easy way to get QBASIC to perform screen
' writes via BIOS or DOS services. QBASIC insists on direct screen
' writes and does a fine job of it too! What happens when you start
' to place your new code in a background partition? You get
' the foreground screen destroyed with dreaded write through. Yeuck!
'
' So, after a "bit" of research with the aid of FILESTAT.BAS and
' ALLFILES.BAS by Lawrence Stone and some gentle nudging from Terri Rossi
' I have come up with this "quick and dirty" fix.
'
' By no means is this an optimum piece of code. It mearly gets the job
' done and allows all my QBASIC programs to output to the screen through
' a DOS Service interrupt like I want and makes them very well behaved
' with DDOS...
'
' I could have used a BIOS interrupt for this, but BIOS only allows single
' character printing where as the chosen DOS Service interrupt allows a
' complete string to be printed. The gotcha here is that the dollar
' string becomes the end-of-line marker and can't be used to show the
' value of currency or what strings are in a program that you may want to
' print out in your program...
'
'
'
'
' setup variables for call to QB.QLB
'
        TYPE REGTYPEX
                AX    AS INTEGER
                bx    AS INTEGER
                CX    AS INTEGER
                dx    AS INTEGER
                bp    AS INTEGER
                si    AS INTEGER
                di    AS INTEGER
                flags AS INTEGER
                ds    AS INTEGER
                es    AS INTEGER
        END TYPE
'
' declare what sub you intend to use in the QB.QLB library
'
        DECLARE SUB INTERRUPTX (intnum AS INTEGER, inreg AS REGTYPEX, outreg AS REGTYPEX)
'
' GOTCHA #1 - This DOS service interrupt &H21, service 9 uses the dollar
' sign "$" as the end-of-line marker! So, if your text contains this
' character, then it becomes the end-of-line. Your string to be printed
' MUST terminate with the dollar sign!!!!!!
'
' This is what you add to the end of EACH line if you want to CR and LF after
' printing the string.
'
        END$ = CHR$(13) + CHR$(10) + "$"
'
' dim the REG(X) array for passing variables
'   
        DIM REG AS REGTYPEX
'
' demo program starts here
'
        CLS
'
' A$ contains the string that you wish to print to screen via
' interrupt &H21, service 9. This interrupt uses the "$" dollar sign as
' the end of a line marker. Sorry, I didn't write this interrupt!
'
        A$ = "Hello, this is a test of DOS interrupt &h21, service 9!"
        A$ = A$ + END$

AGAIN:
'
' Point DS to the segment address of the string
'
        REG.ds = VARSEG(A$)
'
' Point DX to the offset address of the string
'
        REG.dx = SADD(A$)
'
' Setup DOS service 9
'
        REG.AX = &H900
'
' Call the interruptx subroutine in the QB.QLB library
'
        CALL INTERRUPTX(&H21, REG, REG)
'
' Optionally you could write the above line as:
'
' INTERRUPTX &H21, REG, REG
'
'
'
' Loop till B$ contains a key then END
'
        B$ = INKEY$
        IF B$ = "" GOTO AGAIN
        END
'
'
' To compile this "outside" of the QBASIC environment, do this...
'
' BC DOS_SERV.BAS,DOS_SERV.OBJ /O
'
' To link try this...
'
' LINK DOS_SERV.OBJ,DOS_SERV.EXE,,BCOM45.LIB+QB.LIB
'
'
'
'

